<template>
  <div class="roles">
    <modal v-if="modal" :title="title" :menuItems="modalMenuItems" @close="changeModalState">
      <role v-if="isRoleModal" @close="changeModalState" :data="editedRole"/>
      <role-permission-advanced v-else @close="changeModalState"
        :role="editedRole" :data="editedPermission"/>
      <template v-slot:basic>
        <role-permission-basic @close="changeModalState"
          :role="editedRole" :data="editedPermission"/>
      </template>
      <template v-slot:advanced>
        <role-permission-advanced @close="changeModalState"
          :role="editedRole" :data="editedPermission"/>
      </template>
    </modal>
    <div class="wp-title wp-12">Роли</div>
    <nav-bar v-model="search" @action="openRoleModal"/>
    <masonry class="wp-12"
      :columnClass="MasonryColumnClass"
      :cols="MasonryColumns"
      :gutter="MasonryGutter">
      <card v-for="item in filteredRoles" :key="item.id"
        :title="item.name" :menuItems="cardMenuItems" :data="item"
        @delete="removeRole(item.id)" delete
        @create_menu="openPermissionModal"
        @edit_menu="startRoleEdit">
        <template v-slot:info>
          <div class="wp-layout">
            <div class="wp-field">
              <div class="wp-field__title">
                Название
              </div>
              <div class="wp-field__content">
                <div class="wp-field__text">
                  {{ item.name }}
                </div>
              </div>
            </div>
          </div>
        </template>
        <template v-slot:permissions>
          <permissions-table :permissions="item.role_permissions.data"
            @edit="startPermissionEdit"/>
        </template>
      </card>
    </masonry>
  </div>
</template>

<script>
import { mapState, mapActions } from 'vuex';

import { MasonryGutter, MasonryColumnClass, MasonryColumns } from '@/shared';

import NavBar from '@/components/NavBar.vue';
import Card from '@/components/Card.vue';
import PermissionsTable from '@/components/card/PermissionsTable.vue';

import Modal from '@/components/modal/Modal.vue';
import Role from '@/components/modal/orgadmin/roles/Role.vue';
import RolePermissionBasic from '@/components/modal/orgadmin/roles/RolePermissionBasic.vue';
import RolePermissionAdvanced from '@/components/modal/orgadmin/roles/RolePermissionAdvanced.vue';

export default {
  name: 'Roles',
  components: {
    NavBar,
    Card,
    PermissionsTable,
    Modal,
    Role,
    RolePermissionBasic,
    RolePermissionAdvanced,
  },
  data() {
    return {
      MasonryGutter,
      MasonryColumns,
      MasonryColumnClass,
      modal: false,
      isRoleModal: true,
      titles: {
        createRole: 'Новая роль',
        updateRole: 'Редактирование роли',
        createPermission: 'Добавление разрешения',
        updatePermission: 'Редактирование разрешения',
      },
      editedRole: null,
      editedPermission: null,
      search: '',
      createPermissionModalMenuItems: [{
        text: 'Упрощенное',
        prop: 'basic',
      }, {
        text: 'Расширенное',
        prop: 'advanced',
      }],
      cardMenuItems: [{
        text: 'Разрешения',
        prop: 'permissions',
        create: true,
      }, {
        text: 'Информация',
        prop: 'info',
      }],
    };
  },
  computed: {
    ...mapState('organization', ['roles']),
    filteredRoles() {
      return this.roles.filter(role => role.name.toLowerCase().indexOf(
        this.search.toLowerCase(),
      ) !== -1);
    },
    title() {
      if (this.isRoleModal) {
        return this.editedRole ? this.titles.updateRole : this.titles.createRole;
      }
      return this.editedPermission ? this.titles.updatePermission : this.titles.createPermission;
    },
    modalMenuItems() {
      return this.title === this.titles.createPermission
        ? this.createPermissionModalMenuItems : undefined;
    },
  },
  methods: {
    ...mapActions('organization', [
      'getOrganization',
      'deleteRole',
    ]),
    changeModalState() {
      if (this.modal) {
        this.editedRole = null;
        this.editedPermission = null;
      }
      this.modal = !this.modal;
    },
    openRoleModal() {
      this.isRoleModal = true;
      this.changeModalState();
    },
    openPermissionModal(activeMenu, role) {
      this.editedRole = Object.assign({}, role);
      this.isRoleModal = false;
      this.changeModalState();
    },
    startRoleEdit(activeMenu, role) {
      this.editedRole = role;
      this.openRoleModal();
    },
    startPermissionEdit(permission) {
      this.editedPermission = permission;
      this.openPermissionModal();
    },
    async removeRole(roleID) {
      try {
        await this.deleteRole(roleID);
        this.$toasted.success('Роль удалена');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    this.getOrganization();
  },
};
</script>

<style lang="scss" scoped>
</style>
